1 #!/bin/sh -- # no runable script, just for vi
5 # we all like colorful messages
6 if expr match
"$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev
/null
&& \
7 expr match
"$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev
/null
; then
8 CERROR
="\e[1;31m" # red
9 CWARNING
="\e[1;33m" # yellow
10 CMSG
="\e[1;32m" # green
11 CINFO
="\e[1;96m" # light blue
12 CDEBUG
="\e[1;94m" # blue
13 CNORMAL
="\e[0;39m" # default system console color
14 CDONE
="\e[1;32m" # green
15 CPASS
="\e[1;32m" # green
16 CFAIL
="\e[1;31m" # red
17 CCMD
="\e[1;35m" # pink
20 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
21 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
23 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
26 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
27 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
28 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
29 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
32 echo -n "${CINFO}$1${CCMD} " >&2;
33 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
35 if [ -n "$1" ]; then shift; else break; fi
37 echo -n "…${CNORMAL} " >&2;
39 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
40 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
42 if [ $# -gt 0 ]; then echo "${CFAIL}FAIL: $*${CNORMAL}" >&2;
43 else echo "${CFAIL}FAIL${CNORMAL}" >&2; fi
44 EXIT_CODE
=$((EXIT_CODE+1));
47 # enable / disable Debugging
48 MSGLEVEL
=${MSGLEVEL:-3}
49 if [ $MSGLEVEL -le 0 ]; then
52 if [ $MSGLEVEL -le 1 ]; then
56 if [ $MSGLEVEL -le 2 ]; then
60 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
61 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
62 if [ -n "$CFAIL" ]; then
63 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
65 msgfail
() { echo -n " ###FAILED###" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
68 if [ $MSGLEVEL -le 3 ]; then
72 if [ $MSGLEVEL -le 4 ]; then
77 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
78 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
79 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
80 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
81 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
84 echo "${CDONE}DONE${CNORMAL}" >&2;
89 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
90 if [ -f .
/aptconfig.conf
]; then
91 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
92 elif [ -f ..
/aptconfig.conf
]; then
93 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
95 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
98 aptconfig
() { runapt apt
-config $
*; }
99 aptcache
() { runapt apt
-cache $
*; }
100 aptcdrom
() { runapt apt
-cdrom $
*; }
101 aptget
() { runapt apt
-get $
*; }
102 aptftparchive
() { runapt apt
-ftparchive $
*; }
103 aptkey
() { runapt apt
-key $
*; }
104 aptmark
() { runapt apt
-mark $
*; }
106 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
109 if [ -f .
/aptconfig.conf
]; then
110 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
111 elif [ -f ..
/aptconfig.conf
]; then
112 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
114 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
119 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
122 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/methods
/http
126 # error if we about to overflow, but ...
127 # "255 failures ought to be enough for everybody"
128 if [ $EXIT_CODE -gt 255 ]; then
129 msgdie
"Total failure count $EXIT_CODE too big"
131 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
134 shellsetedetector
() {
136 if [ "$exit_status" != '0' ]; then
137 echo >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}"
138 if [ "$EXIT_CODE" = '0' ]; then
139 EXIT_CODE
="$exit_status"
145 if [ "$1" = 'prefix' ]; then
146 CURRENTTRAP
="$2 $CURRENTTRAP"
148 CURRENTTRAP
="$CURRENTTRAP $1"
150 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
154 TMPWORKINGDIRECTORY
=$(mktemp -d)
155 TESTDIRECTORY
=$(readlink -f $(dirname $0))
156 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
157 BUILDDIRECTORY
="${TESTDIRECTORY}/../../build/bin"
158 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
159 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY;"
160 cd $TMPWORKINGDIRECTORY
161 mkdir rootdir aptarchive keys
163 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
164 mkdir -p var
/cache var
/lib var
/log
165 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
166 touch var
/lib
/dpkg
/available
168 ln -s ${BUILDDIRECTORY}/methods usr
/lib
/apt
/methods
170 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
171 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
172 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
174 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
175 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
176 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
178 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
179 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
180 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
181 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
182 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
183 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
184 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
185 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
186 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
187 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
188 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
189 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
190 if ! $(which dpkg) --assert-multi-arch >/dev
/null
2>&1; then
191 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
193 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
194 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
196 export PATH
="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
197 configcompression
'.' 'gz' #'bz2' 'lzma' 'xz'
202 if [ "$1" = "native" -o -z "$1" ]; then
203 eval `aptconfig shell ARCH APT::Architecture`
204 if [ -n "$ARCH" ]; then
207 dpkg
--print-architecture
215 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
218 configarchitecture
() {
220 echo "APT::Architecture \"$(getarchitecture $1)\";"
221 while [ -n "$1" ]; do
222 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
225 } >rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
230 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
231 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
232 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
233 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
235 echo -n > rootdir/var/lib/dpkg/status
238 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
239 if $(which dpkg) --assert-multi-arch >/dev/null 2>&1; then
240 local ARCHS="$(getarchitectures)"
241 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
242 DPKGARCH="$(dpkg --print-architecture)"
243 for ARCH in ${ARCHS}; do
244 if [ "${ARCH}" != "${DPKGARCH}" ]; then
245 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
246 # old-style used e.g. in Ubuntu-P – and as it seems travis
247 echo "DPKG
::options
:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
248 echo "DPKG
::options
:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
252 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
253 # dpkg doesn't really check the version as long as it is fully installed,
254 # but just to be sure we choose one above the required version
255 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
261 configcompression() {
262 while [ -n "$1" ]; do
264 '.') echo ".
\t.
\tcat
";;
265 'gz') echo "gzip\tgz
\tgzip
";;
266 'bz2') echo "bzip2\tbz
2\tbzip
2";;
267 'lzma') echo "lzma
\tlzma
\txz
--format=lzma
";;
268 'xz') echo "xz
\txz
\txz
";;
269 *) echo "$1\t$1\t$1";;
272 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
275 setupsimplenativepackage() {
279 local RELEASE="${4:-unstable}"
280 local DEPENDENCIES="$5"
281 local DESCRIPTION="${6:-"Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
282 If you
find such a package installed on your system
,
283 something went horribly wrong
! They are autogenerated
284 und used only by testcases and surf no other propose…
"}"
286 local SECTION
="${7:-others}"
288 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
291 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
293 local BUILDDIR
=incoming
/${NAME}-${VERSION}
294 mkdir -p ${BUILDDIR}/debian
/source
296 echo "* most suckless software product ever" > FEATURES
297 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
298 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
302 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
303 test -e debian
/control
|| echo "Source: $NAME
306 Maintainer: Joe Sixpack <joe@example.org>
307 Build-Depends: debhelper (>= 7)
308 Standards-Version: 3.9.1
310 Package: $NAME" > debian
/control
311 if [ "$ARCH" = 'all' ]; then
312 echo "Architecture: all" >> debian
/control
314 echo "Architecture: any" >> debian
/control
316 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
317 echo "Description: $DESCRIPTION" >> debian
/control
319 test -e debian
/compat
|| echo "7" > debian
/compat
320 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
321 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
325 buildsimplenativepackage
() {
329 local RELEASE
="${4:-unstable}"
330 local DEPENDENCIES
="$5"
331 local DESCRIPTION
="${6:-"Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
332 If you find such a package installed on your system,
333 something went horribly wrong! They are autogenerated
334 und used only by testcases and surf no other propose…"}"
336 local SECTION="${7:-others}"
337 local PRIORITY="${8:-optional}"
339 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
342 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
344 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
346 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
347 mkdir -p $BUILDDIR/debian/source
348 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
350 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
352 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
353 echo "$NAME ($VERSION) $RELEASE; urgency
=low
357 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
361 Maintainer
: Joe Sixpack
<joe@example.org
>
362 Standards
-Version: 3.9.3" > ${BUILDDIR}/debian/control
363 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
364 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
366 Package
: $NAME" >> ${BUILDDIR}/debian/control
368 if [ "$ARCH" = 'all' ]; then
369 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
371 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
373 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
374 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
375 echo "Description
: $DESCRIPTION" >> ${BUILDDIR}/debian/control
377 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
378 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
380 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
381 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
382 # gpg --yes --no-default-keyring --secret-keyring ./keys/joesixpack.sec \
383 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
384 # --clearsign -o "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
385 # mv "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
389 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
390 rm -rf ${BUILDDIR}/debian
/tmp
391 mkdir -p ${BUILDDIR}/debian
/tmp
/DEBIAN
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
392 cp ${BUILDDIR}/debian
/copyright
${BUILDDIR}/debian
/changelog
${BUILDDIR}/FEATURES
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME}
393 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
/${NAME}-${arch}
394 (cd ${BUILDDIR}; dpkg
-gencontrol -DArchitecture=$arch)
395 (cd ${BUILDDIR}/debian
/tmp
; md5sum $(find usr/ -type f) > DEBIAN
/md5sums
)
397 dpkg
-deb --build ${BUILDDIR}/debian
/tmp
${BUILDDIR}/..
2> /dev
/null
> /dev
/null
398 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.pkglist
401 mkdir -p ${BUILDDIR}/..
/${NAME}_
${VERSION}
402 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}/
403 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}.changelog
412 local ARCH
=$(getarchitecture $4)
413 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
415 if [ "$ARCH" = "all" ]; then
416 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
418 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
419 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
420 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
423 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
426 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
432 if [ -d incoming
]; then
433 buildaptarchivefromincoming $
*
435 buildaptarchivefromfiles $
*
439 createaptftparchiveconfig
() {
440 local COMPRESSORS
="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
441 COMPRESSORS
="${COMPRESSORS%* }"
442 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
443 if [ -z "$ARCHS" ]; then
444 # the pool is empty, so we will operate on faked packages - let us use the configured archs
445 ARCHS
="$(getarchitectures)"
448 ArchiveDir "' >> ftparchive.conf
449 echo -n $(readlink -f .) >> ftparchive.conf
451 CacheDir "' >> ftparchive.conf
452 echo -n $(readlink -f ..) >> ftparchive.conf
454 FileListDir "' >> ftparchive.conf
455 echo -n $(readlink -f pool/) >> ftparchive.conf
459 Packages::Compress "'"$COMPRESSORS"'";
460 Sources::Compress "'"$COMPRESSORS"'";
461 Contents::Compress "'"$COMPRESSORS"'";
462 Translation::Compress "'"$COMPRESSORS"'";
463 LongDescription "false";
467 SrcDirectory "pool/";
473 Label "apttestcases";
475 Description "repository with dummy packages";
476 Architectures "' >> ftparchive.conf
477 echo -n "$ARCHS" >> ftparchive.conf
481 };' >> ftparchive.conf
482 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
483 echo -n 'tree "dists/' >> ftparchive.conf
484 echo -n "$DIST" >> ftparchive.conf
486 Architectures "' >> ftparchive.conf
487 echo -n "$ARCHS" >> ftparchive.conf
489 FileList "' >> ftparchive.conf
490 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
492 SourceFileList "' >> ftparchive.conf
493 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
495 Sections "' >> ftparchive.conf
496 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
498 };' >> ftparchive.conf
502 buildaptftparchivedirectorystructure
() {
503 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
504 for DIST
in $DISTS; do
505 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
506 for SECTION
in $SECTIONS; do
507 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
508 for ARCH
in $ARCHS; do
509 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
511 mkdir -p dists
/${DIST}/${SECTION}/source
512 mkdir -p dists
/${DIST}/${SECTION}/i18n
522 local DEPENDENCIES
="$5"
523 local PRIORITY
="${6:-optional}"
524 local DESCRIPTION
="${7:-"Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
525 If you find such a package installed on your system,
526 something went horribly wrong! They are autogenerated
527 und used only by testcases and surf no other propose…"}"
529 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
530 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
531 ARCHS
="$(getarchitectures)"
535 for BUILDARCH
in $ARCHS; do
536 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
537 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
538 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
539 local FILE
="${PPATH}/Packages"
544 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
545 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
546 echo "Version: $VERSION
547 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
548 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
549 echo "Description: $DESCRIPTION" >> $FILE
560 local DEPENDENCIES
="$5"
562 local SPATH
="aptarchive/dists/${RELEASE}/main/source"
564 local FILE
="${SPATH}/Sources"
568 Maintainer: Joe Sixpack <joe@example.org>
569 Architecture: $ARCH" >> $FILE
570 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
572 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
573 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
577 insertinstalledpackage
() {
581 local DEPENDENCIES
="$4"
582 local PRIORITY
="${5:-optional}"
583 local STATUS
="${6:-install ok installed}"
584 local DESCRIPTION
="${7:-"Description: an autogenerated dummy ${NAME}=${VERSION}/installed
585 If you find such a package installed on your system,
586 something went horribly wrong! They are autogenerated
587 und used only by testcases and surf no other propose…"}"
589 local FILE='rootdir/var/lib/dpkg/status'
590 local INFO='rootdir/var/lib/dpkg/info'
591 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
597 Maintainer: Joe Sixpack <joe@example.org>
598 Version: $VERSION" >> $FILE
599 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
600 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
601 echo "Description: $DESCRIPTION" >> $FILE
603 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
604 echo -n > ${INFO}/${NAME}:${arch}.list
606 echo -n > ${INFO}/${NAME}.list
612 buildaptarchivefromincoming
() {
613 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
615 [ -e pool
] || ln -s ..
/incoming pool
616 [ -e ftparchive.conf
] || createaptftparchiveconfig
617 [ -e dists
] || buildaptftparchivedirectorystructure
618 msgninfo
"\tGenerate Packages, Sources and Contents files… "
619 aptftparchive
-qq generate ftparchive.conf
625 buildaptarchivefromfiles
() {
626 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
627 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
628 msgninfo
"\t${line} file… "
629 compressfile
"$line" "$1"
632 generatereleasefiles
"$@"
636 cat ${TMPWORKINGDIRECTORY}/rootdir
/etc
/testcase
-compressor.conf
| while read compressor extension
command; do
637 if [ "$compressor" = '.' ]; then
643 cat "$1" | $command > "${1}.${extension}"
645 touch -d "$2" "${1}.${extension}"
650 # can be overridden by testcases for their pleasure
651 getcodenamefromsuite
() { echo -n "$1"; }
652 getreleaseversionfromsuite
() { true
; }
653 getlabelfromsuite
() { true
; }
655 generatereleasefiles
() {
656 # $1 is the Date header and $2 is the ValidUntil header to be set
657 # both should be given in notation date/touch can understand
658 msgninfo
"\tGenerate Release files… "
659 if [ -e aptarchive
/dists
]; then
660 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
661 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
662 local CODENAME
="$(getcodenamefromsuite $SUITE)"
663 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
664 local LABEL
="$(getlabelfromsuite $SUITE)"
665 if [ -n "$VERSION" ]; then
666 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
668 if [ -n "$LABEL" ]; then
669 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
671 aptftparchive
-qq release
$dir \
672 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
673 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
676 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
677 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
679 NotAutomatic: yes' $dir/Release
681 if [ -n "$1" -a "$1" != "now" ]; then
682 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
686 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
690 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
692 if [ -n "$1" -a "$1" != "now" ]; then
693 for release
in $(find ./aptarchive -name 'Release'); do
694 touch -d "$1" $release
700 setupdistsaptarchive
() {
701 local APTARCHIVE
=$(readlink -f ./aptarchive)
702 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
703 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
704 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
705 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
706 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
707 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
708 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
713 setupflataptarchive
() {
714 local APTARCHIVE
=$(readlink -f ./aptarchive)
715 if [ -f ${APTARCHIVE}/Packages
]; then
716 msgninfo
"\tadd deb sources.list line… "
717 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
720 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
722 if [ -f ${APTARCHIVE}/Sources
]; then
723 msgninfo
"\tadd deb-src sources.list line… "
724 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
727 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
733 if [ -e aptarchive
/dists
]; then
739 if [ "$1" != '--no-update' ]; then
740 msgninfo
"\tSync APT's cache with the archive… "
747 local SIGNER
="${1:-Joe Sixpack}"
748 local GPG
="gpg --batch --yes --no-default-keyring --trustdb-name rootdir/etc/apt/trustdb.gpg"
749 msgninfo
"\tSign archive with $SIGNER key… "
750 local REXKEY
='keys/rexexpired'
751 local SECEXPIREBAK
="${REXKEY}.sec.bak"
752 local PUBEXPIREBAK
="${REXKEY}.pub.bak"
753 if [ "${SIGNER}" = 'Rex Expired' ]; then
754 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
755 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
756 # therefore we 'temporary' make the key not expired and restore a backup after signing
757 cp ${REXKEY}.sec
$SECEXPIREBAK
758 cp ${REXKEY}.pub
$PUBEXPIREBAK
759 local SECUNEXPIRED
="${REXKEY}.sec.unexpired"
760 local PUBUNEXPIRED
="${REXKEY}.pub.unexpired"
761 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
762 cp $SECUNEXPIRED ${REXKEY}.sec
763 cp $PUBUNEXPIRED ${REXKEY}.pub
765 printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub
--secret-keyring ${REXKEY}.sec
--command-fd 0 --edit-key "${SIGNER}" >/dev
/null
2>&1 || true
766 cp ${REXKEY}.sec
$SECUNEXPIRED
767 cp ${REXKEY}.pub
$PUBUNEXPIRED
770 for KEY
in $(find keys/ -name '*.sec'); do
771 GPG
="$GPG --secret-keyring $KEY"
773 for KEY
in $(find keys/ -name '*.pub'); do
774 GPG
="$GPG --keyring $KEY"
776 for RELEASE
in $(find aptarchive/ -name Release); do
777 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg
${RELEASE}
778 local INRELEASE
="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
779 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
780 # we might have set a specific date for the Release file, so copy it
781 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg
${INRELEASE}
783 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
784 mv -f $SECEXPIREBAK ${REXKEY}.sec
785 mv -f $PUBEXPIREBAK ${REXKEY}.pub
790 rewritesourceslist
() {
791 local APTARCHIVE
="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
792 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
793 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#"
797 changetowebserver
() {
798 local LOG
='/dev/null'
799 if test -x ${BUILDDIRECTORY}/aptwebserver
; then
801 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/aptwebserver
-o aptwebserver
::fork
=1 "$@" >$LOG 2>&1
802 local PID
="$(cat aptwebserver.pid)"
803 if [ -z "$PID" ]; then
804 msgdie
'Could not fork aptwebserver successfully'
809 msgdie
'You have to build aptwerbserver or install a webserver'
811 if [ "$1" != '--no-rewrite' ]; then
812 rewritesourceslist
'http://localhost:8080/'
816 changetohttpswebserver
() {
817 if ! which stunnel4
>/dev
/null
; then
818 msgdie
'You need to install stunnel4 for https testcases'
820 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
821 changetowebserver
--no-rewrite
823 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
824 cert = ${TESTDIRECTORY}/apt.pem
829 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
830 stunnel4
"${TMPWORKINGDIRECTORY}/stunnel.conf"
831 local PID
="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
832 addtrap
'prefix' "kill ${PID};"
833 rewritesourceslist
'https://localhost:4433/'
837 mkdir -p rootdir
/media
/cdrom
/.disk
838 local CD
="$(readlink -f rootdir/media/cdrom)"
839 echo "acquire::cdrom::mount \"${CD}\";" > rootdir
/etc
/apt
/apt.conf.d
/00cdrom
840 echo 'acquire::cdrom::autodetect 0;' >> rootdir
/etc
/apt
/apt.conf.d
/00cdrom
841 echo -n "$1" > ${CD}/.disk
/info
842 if [ ! -d aptarchive
/dists
]; then
843 msgdie
'Flat file archive cdroms can not be created currently'
846 mv aptarchive
/dists
$CD
847 ln -s "$(readlink -f ./incoming)" $CD/pool
848 find rootdir
/etc
/apt
/sources.list.d
/ -name 'apt-test-*.list' -delete
852 PROTO
="$(echo "$1" | cut -d':' -f 1)"
853 local DOWNLOG
="${TMPWORKINGDIRECTORY}/download.log"
857 echo "601 Configuration
858 Config-Item: Acquire::https::CaInfo=${TESTDIR}/apt.pem
859 Config-Item: Debug::Acquire::${PROTO}=1
865 # simple worker keeping stdin open until we are done (201) or error (400)
866 # and requesting new URIs on try-agains/redirects inbetween
867 { tail -n 999 -f "$DOWNLOG" & echo "TAILPID: $!"; } | while read f1 f2
; do
868 if [ "$f1" = 'TAILPID:' ]; then
870 elif [ "$f1" = 'New-URI:' ]; then
871 echo "600 Acquire URI
875 elif [ "$f1" = '201' ] || [ "$f1" = '400' ]; then
876 # tail would only die on next read – which never happens
877 test -z "$TAILPID" || kill -s HUP
"$TAILPID"
881 } | LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/methods
/${PROTO} 2>&1 | tee "$DOWNLOG"
883 # only if the file exists the download was successful
892 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
893 if [ -n "$DIFFTEXT" ]; then
905 msgtest
"Test for correctness of file" "$FILE"
907 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
909 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
914 msgtest
"Test for no output of" "$*"
915 test -z "$($* 2>&1)" && msgpass
|| msgfail
919 local COMPAREFILE
=$(mktemp)
920 addtrap
"rm $COMPAREFILE;"
921 echo "$1" > $COMPAREFILE
923 msgtest
"Test for equality of" "$*"
924 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
928 local COMPAREFILE1
=$(mktemp)
929 local COMPAREFILE2
=$(mktemp)
930 local COMPAREAGAINST
=$(mktemp)
931 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
932 echo "$1" > $COMPAREFILE1
933 echo "$2" > $COMPAREFILE2
935 msgtest
"Test for equality OR of" "$*"
936 $
* >$COMPAREAGAINST 2>&1 || true
937 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
938 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
939 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
940 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
945 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
948 while [ -n "$1" ]; do
950 N: Can't select versions from package '$1' as it is purely virtual"
951 PACKAGE
="${PACKAGE} $1"
954 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
956 N: No packages found"
957 local COMPAREFILE
=$(mktemp)
958 addtrap
"rm $COMPAREFILE;"
959 local ARCH
="$(getarchitecture 'native')"
960 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
961 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
965 msgtest
"Test for non-existent packages" "apt-cache show $*"
966 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
967 if [ -n "$SHOWPKG" ]; then
976 testdpkginstalled
() {
977 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
978 local PKGS
="$(dpkg -l $* 2>/dev/null | grep '^i' | wc -l)"
979 if [ "$PKGS" != $# ]; then
981 dpkg
-l $
* | grep '^[a-z]'
988 testdpkgnotinstalled
() {
989 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
990 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
991 if [ "$PKGS" != 0 ]; then
993 dpkg
-l $
* | grep '^[a-z]'
1001 local COMPAREFILE
=$(mktemp)
1002 addtrap
"rm $COMPAREFILE;"
1003 if [ -n "$1" ]; then
1004 msgtest
'Test for correctly marked as auto-installed' "$*"
1005 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1007 msgtest
'Test for correctly marked as auto-installed' 'no package'
1008 echo -n > $COMPAREFILE
1010 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1014 if [ "$1" = '--nomsg' ]; then
1017 msgtest
'Test for successful execution of' "$*"
1019 local OUTPUT
=$(mktemp)
1020 addtrap
"rm $OUTPUT;"
1021 if $@
>${OUTPUT} 2>&1; then
1031 if [ "$1" = '--nomsg' ]; then
1034 msgtest
'Test for failure in execution of' "$*"
1036 local OUTPUT
=$(mktemp)
1037 addtrap
"rm $OUTPUT;"
1038 if $@
>${OUTPUT} 2>&1; then
1048 echo "STOPPED execution. Press enter to continue"